﻿using Infragistics.Win;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CheckedItemsComboEditor
{
    public partial class Form1 : Form
    {
        private DataTable table = null;
        IList values = null;

        public Form1()
        {
            InitializeComponent();
            ultraComboEditor1.ValueChanged += ultraComboEditor1_ValueChanged;
            ultraComboEditor1.AfterCloseUp += ultraComboEditor1_AfterCloseUp;
        }

        void ultraComboEditor1_AfterCloseUp(object sender, EventArgs e)
        {
            this.ultraComboEditor1.DataSource = values;
        }

    
        void ultraComboEditor1_ValueChanged(object sender, EventArgs e)
        {           
            //Populate a list with "checked/selected" items
            values = this.ultraComboEditor1.Value as IList;            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //  Bind the UltraComboEditor control to a data source.
            this.ultraComboEditor1.DisplayMember = "Display";
            this.ultraComboEditor1.ValueMember = "Value";
            this.ultraComboEditor1.DataSource = this.Table;
            this.ultraComboEditor1.CheckedListSettings.CheckBoxStyle = Infragistics.Win.CheckStyle.CheckBox;

            this.ultraComboEditor1.CheckedListSettings.EditorValueSource = EditorWithComboValueSource.CheckedItems; 
        }

        private DataTable Table
        {
            get
            {
                if (this.table == null)
                {
                    this.table = new DataTable();
                    this.table.Columns.Add("Value", typeof(object));
                    this.table.Columns.Add("Display", typeof(string));
                    this.table.Columns.Add("Selected", typeof(bool));

                    this.table.Rows.Add(new object[] { 1, "One", false });
                    this.table.Rows.Add(new object[] { 2, "Two", false });
                    this.table.Rows.Add(new object[] { 3, "Three", false });
                    this.table.Rows.Add(new object[] { 4, "Four", false });
                    this.table.Rows.Add(new object[] { 5, "Five", false });
                }

                return this.table;
            }
        }

    }
}
